import { ResolutionCondition } from '../types';
import { Token, TokenType } from '../pointers';
import { BindSyntax, TypeSyntax } from './syntax';
export declare class Container {
    parent?: Container | undefined;
    private vault;
    private snapshot;
    constructor(parent?: Container | undefined);
    clone(): Container;
    capture(): void;
    restore(): void;
    bind<T extends Token>(token: T): TypeSyntax<TokenType<T>>;
    when(condition: ResolutionCondition): BindSyntax;
    get<T extends Token>(token: T): TokenType<T>;
    /**
     * @access package
     * @deprecated `conditions` argument is added for internal use.
     *              Use it if you really understand that it is necessary.
     */
    get<T extends Token>(token: T, conditions: ResolutionCondition[]): TokenType<T>;
    private getSingle;
    private getMultiple;
    private resolveBinding;
    private resolveValue;
    private resolveCreator;
    private resolveParameters;
    private call;
    private construct;
}
