import { UnknownConstructor, UnknownCreator, UnknownFunction } from '../../types';
import { Binding, Scope, Type } from './Binding';
export declare class FactoryBinding implements Binding {
    readonly value: {
        creator: UnknownCreator;
        initializer?: (entity: unknown, ...args: unknown[]) => unknown;
        isConstructor: boolean;
    };
    readonly type = Type.Factory;
    readonly scope = Scope.Transient;
    constructor(value: {
        creator: UnknownCreator;
        initializer?: (entity: unknown, ...args: unknown[]) => unknown;
        isConstructor: boolean;
    });
}
export interface FactoryConstructorBinding extends FactoryBinding {
    readonly value: {
        creator: UnknownConstructor;
        initializer?: (instance: unknown, ...args: unknown[]) => unknown;
        isConstructor: true;
    };
}
export interface FactoryFunctionBinding extends FactoryBinding {
    readonly value: {
        creator: UnknownFunction;
        initializer?: (entity: unknown, ...args: unknown[]) => unknown;
        isConstructor: false;
    };
}
export declare const isFactoryBinding: (binding: Binding) => binding is FactoryBinding;
export declare const isFactoryConstructorBinding: (binding: FactoryBinding) => binding is FactoryConstructorBinding;
