export declare type Token<T = unknown> = symbol & {
    __type__: T;
};
export declare type TokenType<T> = T extends Token ? T['__type__'] : never;
export declare type TokensType<T> = {
    [K in keyof T]: T[K] extends Token ? TokenType<T[K]> : TokensType<T[K]>;
};
export declare const token: <T>(description: string) => Token<T>;
