import { Tag } from './pointers';
export declare type UnknownConstructor<T extends Object = Object> = new (...args: any[]) => T;
export declare type UnknownFunction<T = unknown> = (...args: any[]) => T;
export declare type UnknownCreator = UnknownConstructor | UnknownFunction;
export declare type UnknownCreatorParameters<T extends UnknownCreator> = T extends UnknownConstructor ? ConstructorParameters<T> : T extends UnknownFunction ? Parameters<T> : never;
export declare type ResolutionCondition = Tag | UnknownCreator;
export declare type Factory<T extends unknown, A extends unknown[] = []> = (...args: A) => T;
export declare type Creator<T, A extends unknown[] = []> = Factory<T, A>;
